# Google Cloud Spanner v1 API - Class RoutingHint (5.13.0-beta07)

5.13.0-beta07 5.13.0-beta06 5.12.0 (latest) 5.11.0 5.10.0 5.9.0 5.8.0 5.7.0 5.6.0 5.5.0 5.4.0 5.3.0 5.2.0 5.1.0 5.0.0 4.6.0 4.5.0 4.4.0 4.3.0 4.2.0 4.1.0 4.0.0 3.15.1 3.14.0 3.13.0 3.12.0 3.11.0 3.10.0 3.9.0 3.8.0 3.7.0 3.6.0 3.5.0

    public sealed class RoutingHint : IMessage<RoutingHint>, IEquatable<RoutingHint>, IDeepCloneable<RoutingHint>, IBufferMessage, IMessage

Reference documentation and code samples for the Google Cloud Spanner v1 API class RoutingHint.

`RoutingHint` can be optionally added to location-aware Spanner
requests. It gives the server hints that can be used to route the request to
an appropriate server, potentially significantly decreasing latency and
improving throughput. To achieve improved performance, most fields must be
filled in with accurate values.

The presence of a valid `RoutingHint` tells the server that the client
is location-aware.

`RoutingHint` does not change the semantics of the request; it is
purely a performance hint; the request will perform the same actions on the
database's data as if `RoutingHint` were not present. However, if
the `RoutingHint` is incomplete or incorrect, the response may include
a `CacheUpdate` the client can use to correct its location cache.

## Inheritance

[object](https://learn.microsoft.com/dotnet/api/system.object) \> RoutingHint

## Implements

[IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage-1.html)[RoutingHint](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHint), [IEquatable](https://learn.microsoft.com/dotnet/api/system.iequatable-1)[RoutingHint](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHint), [IDeepCloneable](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IDeepCloneable-1.html)[RoutingHint](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHint), [IBufferMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IBufferMessage.html), [IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage.html)

## Inherited Members

[object.GetHashCode()](https://learn.microsoft.com/dotnet/api/system.object.gethashcode) [object.GetType()](https://learn.microsoft.com/dotnet/api/system.object.gettype) [object.ToString()](https://learn.microsoft.com/dotnet/api/system.object.tostring)

## Namespace

[Google.Cloud.Spanner.V1](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1)

## Assembly

Google.Cloud.Spanner.V1.dll

## Constructors

### RoutingHint()

    public RoutingHint()

### RoutingHint(RoutingHint)

    public RoutingHint(RoutingHint other)

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `other` | `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHint` |

## Properties

### ClientLocation

    public string ClientLocation { get; set; }

If present, the client's current location. This should be the name of a
Google Cloud zone or region, such as "us-central1".

If absent, the client's location will be assumed to be the same as the
location of the server the client ends up connected to.

Locations are primarily valuable for clients that connect from regions
other than the ones that contain the Spanner database.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.string` |   |

### DatabaseId

    public ulong DatabaseId { get; set; }

The database ID of the database being accessed, see
`CacheUpdate.database_id`. Should match the cache entries that were used
to generate the rest of the fields in this `RoutingHint`.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.uint64` |   |

### GroupUid

    public ulong GroupUid { get; set; }

The group UID of the group that the client believes serves the range
defined by `key` and `limit_key`. See `Range.group_uid` for more details.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.uint64` |   |

### Key

    public ByteString Key { get; set; }

The key / key range that this request accesses. For operations that
access a single key, `key` should be set and `limit_key` should be empty.
For operations that access a key range, `key` and `limit_key` should both
be set, to the inclusive start and exclusive end of the range respectively.

The keys are encoded in "sortable string format" (ssformat), using a
`KeyRecipe` that is appropriate for the request. See `KeyRecipe` for more
details.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.ByteString.html` |   |

### LimitKey

    public ByteString LimitKey { get; set; }

If this request targets a key range, this is the exclusive end of the
range. See `key` for more details.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.ByteString.html` |   |

### OperationUid

    public ulong OperationUid { get; set; }

A session-scoped unique ID for the operation, computed client-side.
Requests with the same `operation_uid` should have a shared 'shape',
meaning that some fields are expected to be the same, such as the SQL
query, the target table/columns (for reads) etc. Requests with the same
`operation_uid` are meant to differ only in fields like keys/key
ranges/query parameters, transaction IDs, etc.

`operation_uid` must be non-zero for `RoutingHint` to be valid.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.uint64` |   |

### SchemaGeneration

    public ByteString SchemaGeneration { get; set; }

The schema generation of the recipe that was used to generate `key` and
`limit_key`. See also `RecipeList.schema_generation`.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.ByteString.html` |   |

### SkippedTabletUid

    public RepeatedField<RoutingHint.Types.SkippedTablet> SkippedTabletUid { get; }

If the client had multiple options for tablet selection, and some of its
first choices were unhealthy (e.g., the server is unreachable, or
`Tablet.skip` is true), this field will contain the tablet UIDs of those
tablets, with their incarnations. The server may include a `CacheUpdate`
with new locations for those tablets.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.Collections.RepeatedField-1.htmlhttps://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHinthttps://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHint.Typeshttps://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.RoutingHint.Types.SkippedTablet` |   |

### SplitId

    public ulong SplitId { get; set; }

The split ID of the split that the client believes contains the range
defined by `key` and `limit_key`. See `Range.split_id` for more details.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.uint64` |   |

### TabletUid

    public ulong TabletUid { get; set; }

The tablet UID of the tablet from group `group_uid` that the client
believes is best to serve this request. See `Group.local_tablet_uids` and
`Group.leader_tablet_uid`.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.uint64` |   |